﻿using HeuristicLab.Common;
using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Problems.Robocode {
  [StorableClass]
  public class GetRadarHeading : CodeNode, INumericalMethod {
    public override int MinimumArity { get { return 0; } }
    public override int MaximumArity { get { return 0; } }

    [Storable]
    public override string Prefix { get; set; }

    [Storable]
    public override string Suffix { get; set; }

    [StorableConstructor]
    private GetRadarHeading(bool deserializing) : base(deserializing) { }
    private GetRadarHeading(GetRadarHeading original, Cloner cloner)
      : base(original, cloner) {
    }

    public GetRadarHeading()
      : base("GetRadarHeading", "Returns the direction that the robot's radar is facing, in degrees.") {
      this.Prefix = "getRadarHeading(";
      this.Suffix = ")";
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new GetRadarHeading(this, cloner);
    }

    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
      return this.Prefix + this.Suffix;
    }
  }
}